#! /usr/bin/env lua

-- ListStore example

require("lgui")

local list = lgui.ListStore.new("glong", "gchar")
local iter = lgui.TreeIter.new()

-- Adding some values
for i = 1, 10 do
	list:append(iter)
	list:seto(iter, i * 50, "c")
end

-- Getting the values

local valid = lgui.TreeModel.getIterFirst(list, iter)
local getm = lgui.TreeModel.get
local iterNext = lgui.TreeModel.iterNext

while valid do
	print(getm(list, iter, 0, 1))
	valid = iterNext(list, iter)
end

-- Another way of iteration
lgui.TreeModel.foreach(list, 
	function(data, path, iter)
		local a, b = getm(list, iter, 0, 1)
		print(a, b, data)
		return false -- false continue the iteration, true stops
	end, "My data")
