/*
	This file is part of lgui.

	lgui is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lgui is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lgui.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2008 Lucas Hermann Negri
*/

#ifdef HAVE_GLADE
#include "glade.h"

int lgui_glade_xml_new(lua_State* L)
{
	gint size = lua_gettop(L);
	luaL_checktype(L, 1, LUA_TSTRING);
	gchar* root = NULL;
	gchar* domain = NULL;

	if(size >= 2)
	{
		luaL_checktype(L, 2, LUA_TSTRING);
		root = (gchar*)lua_tostring(L, 2);

		if(size >= 3)
		{
			luaL_checktype(L, 3, LUA_TSTRING);
			domain = (gchar*)lua_tostring(L, 3);
		}
	}

	GladeXML* ptr = glade_xml_new(lua_tostring(L, 1), root, domain);
	object_new(L, ptr, TRUE);
	
	return 1;
}

int lgui_glade_xml_new_from_buffer(lua_State* L)
{	
	luaL_checktype(L, 1, LUA_TSTRING);
	int size = lua_gettop(L), len;
	
	gchar* buffer = (gchar*)lua_tostring(L, 1);
	len = -1;
	gchar* root = NULL;
	gchar* domain = NULL;

	if(size >= 2)
	{
		luaL_checktype(L, 2, LUA_TSTRING);
		root = (gchar*)lua_tostring(L, 2);

		if(size >= 3)
		{
			luaL_checktype(L, 3, LUA_TSTRING);
			domain = (gchar*)lua_tostring(L, 3);
		}
	}

	GladeXML* ptr = glade_xml_new_from_buffer(buffer, len, root, domain);
	object_new(L, ptr, TRUE);
	
	return 1;
}

int lgui_glade_xml_get_widget(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TUSERDATA);
	Object* obj = lua_touserdata(L, 1);
	int i, size = lua_gettop(L);

	for(i = 2; i <= size; i++)
	{
		luaL_checktype(L, i, LUA_TSTRING);
		GtkWidget* ptr = glade_xml_get_widget(GLADE_XML(obj->pointer), lua_tostring(L, i));

		object_new(L, ptr, FALSE);
	}

	return size - 1;
}
#endif
