/*
	This file is part of lgui.

	lgui is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lgui is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lgui.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2008 Lucas Hermann Negri
*/

#ifndef LGUI_MENU
#define LGUI_MENU

#include "widget.h"

/* MenuShell */

int lgui_menu_shell_append(lua_State* L);
int lgui_menu_shell_insert(lua_State* L);

/* GtkMenuBar */

int lgui_menu_bar_new(lua_State* L);

/* GtkMenu */

int lgui_menu_new(lua_State* L);
int lgui_menu_popup(lua_State* L);

/* GtkMenuItem */

int lgui_menu_item_new(lua_State* L);
int lgui_menu_item_new_with_mnemonic(lua_State* L);
int lgui_menu_item_set_submenu(lua_State* L);

/* GtkImageMenuItem */

int lgui_image_menu_item_new(lua_State* L);
int lgui_image_menu_item_new_from_stock(lua_State* L);

/* GtkCheckMenuItem */

int lgui_check_menu_item_new_with_mnemonic(lua_State* L);

/* GtkTearoffMenuItem */

int lgui_tearoff_menu_item_new(lua_State* L);

/* GtkSeparatorMenuItem */

int lgui_separator_menu_item_new(lua_State* L);

#endif
