/*
	This file is part of lgui.

	lgui is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lgui is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lgui.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2008 Lucas Hermann Negri
*/

#include "notebook.h"

int lgui_notebook_new(lua_State* L)
{
	GtkWidget* ptr = gtk_notebook_new();
	object_new(L, ptr, FALSE);
	
	return 1;
}

int lgui_notebook_insert_page(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TUSERDATA);
	luaL_checktype(L, 2, LUA_TUSERDATA);
	luaL_checktype(L, 3, LUA_TUSERDATA);
	
	int top = lua_gettop(L);
	int pos = -1;
	
	Object* obj1 = lua_touserdata(L, 1);
	Object* obj2 = lua_touserdata(L, 2);
	Object* obj3 = lua_touserdata(L, 3);
	
	if(top >= 4)
	{
		luaL_checktype(L, 4, LUA_TNUMBER);
		pos = lua_tointeger(L, 4);
	}
	
	gint res = gtk_notebook_insert_page(GTK_NOTEBOOK(obj1->pointer),
	GTK_WIDGET(obj2->pointer), GTK_WIDGET(obj3->pointer), pos);
	
	lua_pushnumber(L, res);
	
	return 1;
}

int lgui_notebook_insert_page_menu(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TUSERDATA);
	luaL_checktype(L, 2, LUA_TUSERDATA);
	luaL_checktype(L, 3, LUA_TUSERDATA);
	luaL_checktype(L, 4, LUA_TUSERDATA);
	
	int top = lua_gettop(L);
	int pos = -1;
	
	Object* obj1 = lua_touserdata(L, 1);
	Object* obj2 = lua_touserdata(L, 2);
	Object* obj3 = lua_touserdata(L, 3);
	Object* obj4 = lua_touserdata(L, 4);
	
	if(top >= 5)
	{
		luaL_checktype(L, 5, LUA_TNUMBER);
		pos = lua_tointeger(L, 5);
	}
	
	gint res = gtk_notebook_insert_page_menu(GTK_NOTEBOOK(obj1->pointer), GTK_WIDGET(obj2->pointer),
	GTK_WIDGET(obj3->pointer), GTK_WIDGET(obj4->pointer), pos);
	
	lua_pushnumber(L, res);
	
	return 1;
}


int lgui_notebook_remove_page(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TUSERDATA);
	luaL_checktype(L, 2, LUA_TNUMBER);
	
	Object* obj = lua_touserdata(L, 1);
	gtk_notebook_remove_page(GTK_NOTEBOOK(obj->pointer), lua_tointeger(L, 2));
	
	return 0;
}
