/*
	This file is part of lgui.

	lgui is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lgui is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lgui.  If not, see <http://www.gnu.org/licenses/>.

    Copyright (C) 2008 Lucas Hermann Negri
*/

#ifndef LGUI_PROXYLIST
#define LGUI_PROXYLIST

#include "lgui.h"

#define LGUI_TYPE_PROXY_LIST			(lgui_proxy_list_get_type())
#define LGUI_PROXY_LIST(obj)			(G_TYPE_CHECK_INSTANCE_CAST((obj), LGUI_TYPE_PROXY_LIST, LguiProxyList))
#define LGUI_PROXY_LIST_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), LGUI_TYPE_PROXY_LIST, LguiProxyListClass))
#define LGUI_IS_PROXY_LIST(obj)			(G_TYPE_CHECK_INSTANCE_TYPE ((obj), LGUI_TYPE_PROXY_LIST))
#define LGUI_IS_PROXY_LIST_CLASS		(klass)(G_TYPE_CHECK_CLASS_TYPE((klass), LGUI_TYPE_PROXY_LIST))
#define LGUI_PROXY_LIST_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), LGUI_TYPE_PROXY_LIST, LguiProxyListClass))

typedef struct _LguiProxyList       LguiProxyList;
typedef struct _LguiProxyListClass  LguiProxyListClass;

struct _LguiProxyList
{
	/* Std */
	GObject parent;
	gint stamp;
	
	/* Columns */
	gint n_columns;
	GType* column_types;
	
	/* Lua */
	lua_State *L;
	int table;
};

struct _LguiProxyListClass
{
	GObjectClass parent_class;
};

GType lgui_proxy_list_get_type();

/* lgui */
int lgui_proxy_list_new(lua_State* L);
int lgui_proxy_list_set_value(lua_State* L);

#endif
