/*
	This file is part of lgui.

	lgui is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lgui is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lgui.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2008 Lucas Hermann Negri
*/

#include "scale.h"

int lgui_hscale_new(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TUSERDATA);
	Object* obj = lua_touserdata(L, 1);

	GtkWidget* ptr = gtk_hscale_new(GTK_ADJUSTMENT(obj->pointer));
	object_new(L, ptr, FALSE);

	return 1;
}

int lgui_hscale_new_with_range(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TNUMBER);
	luaL_checktype(L, 2, LUA_TNUMBER);
	luaL_checktype(L, 3, LUA_TNUMBER);

	GtkWidget* ptr = gtk_hscale_new_with_range(lua_tonumber(L, 1),
	lua_tonumber(L, 2), lua_tonumber(L, 3));
	object_new(L, ptr, FALSE);

	return 1;
}

int lgui_vscale_new(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TUSERDATA);
	Object* obj = lua_touserdata(L, 1);

	GtkWidget* ptr = gtk_vscale_new(GTK_ADJUSTMENT(obj->pointer));
	object_new(L, ptr, FALSE);

	return 1;
}

int lgui_vscale_new_with_range(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TNUMBER);
	luaL_checktype(L, 2, LUA_TNUMBER);
	luaL_checktype(L, 3, LUA_TNUMBER);

	GtkWidget* ptr = gtk_vscale_new_with_range(lua_tonumber(L, 1),
	lua_tonumber(L, 2), lua_tonumber(L, 3));
	object_new(L, ptr, FALSE);

	return 1;
}
