/*
	This file is part of lgui.

	lgui is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lgui is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lgui.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2008 Lucas Hermann Negri
*/

#ifndef LGUI_TEXT
#define LGUI_TEXT

#include "widget.h"

/* GtkTextView */

int lgui_text_view_new(lua_State* L);
int lgui_text_view_new_with_buffer(lua_State* L);
int lgui_text_view_scroll_to_iter(lua_State* L);
int lgui_text_view_scroll_to_mark(lua_State* L);

/* GtkTextTagTable */

int lgui_text_tag_table_add(lua_State* L);
int lgui_text_tag_table_remove(lua_State* L);
int lgui_text_tag_table_lookup(lua_State* L);
int lgui_text_tag_table_get_size(lua_State* L);

/* GtkTextBuffer */

int lgui_text_buffer_new(lua_State* L);
int lgui_text_buffer_get_line_count(lua_State* L);
int lgui_text_buffer_get_char_count(lua_State* L);
int lgui_text_buffer_insert(lua_State* L);
int lgui_text_buffer_insert_with_tags(lua_State* L);
int lgui_text_buffer_insert_pixbuf(lua_State* L);
int lgui_text_buffer_get_start_iter(lua_State* L);
int lgui_text_buffer_get_end_iter(lua_State* L);
int lgui_text_buffer_get_iter_at_offset(lua_State* L);
int lgui_text_buffer_get_iter_at_line(lua_State* L);
int lgui_text_buffer_get_iter_at_line_offset(lua_State* L);
int lgui_text_buffer_create_tag(lua_State* L);
int lgui_text_buffer_select_range(lua_State* L);
int lgui_text_buffer_get_selection_bounds(lua_State* L);
int lgui_text_buffer_get_iter_at_mark(lua_State* L);
int lgui_text_buffer_create_mark(lua_State* L);
int lgui_text_buffer_move_mark(lua_State* L);
int lgui_text_buffer_delete_mark(lua_State* L);
int lgui_text_buffer_delete(lua_State* L);
int lgui_text_buffer_get_mark(lua_State* L);
int lgui_text_buffer_place_cursor(lua_State* L);
int lgui_text_buffer_delete_selection(lua_State* L);
int lgui_text_buffer_copy_clipboard(lua_State* L);
int lgui_text_buffer_cut_clipboard(lua_State* L);
int lgui_text_buffer_paste_clipboard(lua_State* L);

/* GtkTextIter */

int lgui_text_iter_new(lua_State* L);
int lgui_text_iter_set_offset(lua_State* L);
int lgui_text_iter_get_offset(lua_State* L);
int lgui_text_iter_set_line(lua_State* L);
int lgui_text_iter_get_line(lua_State* L);
int lgui_text_iter_forward_search(lua_State* L);
int lgui_text_iter_backward_search(lua_State* L);

#endif
