/*
	This file is part of lgui.

	lgui is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lgui is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lgui.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2008 Lucas Hermann Negri
*/

#ifndef LGUI_TREEMODEL
#define LGUI_TREEMODEL

#include "lgui.h"

/* GtkTreeIter */

int lgui_tree_iter_new(lua_State* L);
int lgui_tree_iter_copy(lua_State* L);

/* GtkTreePath */

int lgui_tree_path_new(lua_State* L);
int lgui_tree_path_new_first(lua_State* L);
int lgui_tree_path_new_from_string(lua_State* L);
int lgui_tree_path_copy(lua_State* L);
int lgui_tree_path_compare(lua_State* L);
int lgui_tree_path_append_index(lua_State* L);
int lgui_tree_path_prepend_index(lua_State* L);
int lgui_tree_path_get_depth(lua_State* L);
int lgui_tree_path_get_indices(lua_State* L);
int lgui_tree_path_next(lua_State* L);
int lgui_tree_path_prev(lua_State* L);
int lgui_tree_path_up(lua_State* L);
int lgui_tree_path_down(lua_State* L);
int lgui_tree_path_is_ancestor(lua_State* L);
int lgui_tree_path_is_descendant(lua_State* L);

/* GtkTreeModel */

int lgui_tree_model_get_iter(lua_State* L);
int lgui_tree_model_get_iter_from_string(lua_State* L);
int lgui_tree_model_get_string_from_iter(lua_State* L);
int lgui_tree_model_get_iter_first(lua_State* L);
int lgui_tree_model_iter_next(lua_State* L);
int lgui_tree_model_get(lua_State* L);
int lgui_tree_model_get_path(lua_State* L);
int lgui_tree_model_get_n_columns(lua_State* L);
int lgui_tree_model_foreach(lua_State* L);
int lgui_tree_model_row_changed(lua_State* L);
int lgui_tree_model_row_inserted(lua_State* L);
int lgui_tree_model_row_has_child_toggled(lua_State* L);
int lgui_tree_model_row_deleted(lua_State* L);
int lgui_tree_model_rows_reordered(lua_State* L);

#endif
