/*
	This file is part of lgui.

	lgui is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	lgui is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with lgui.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2008 Lucas Hermann Negri
*/

#include "treemodelsort.h"

int lgui_tree_model_sort_new_with_model(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TUSERDATA);
	Object* obj = lua_touserdata(L, 1);
	
	GtkTreeModel* ptr = gtk_tree_model_sort_new_with_model(
		GTK_TREE_MODEL(obj->pointer));
	
	object_new(L, ptr, TRUE);
	return 1;
}

int lgui_tree_model_sort_convert_child_iter_to_iter(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TUSERDATA);
	luaL_checktype(L, 2, LUA_TUSERDATA);
	luaL_checktype(L, 3, LUA_TUSERDATA);
	
	Object* obj1 = lua_touserdata(L, 1);
	Object* obj2 = lua_touserdata(L, 2);
	Object* obj3 = lua_touserdata(L, 3);
	
#if GTK_MINOR_VERSION >= 13	
	gboolean res = gtk_tree_model_sort_convert_child_iter_to_iter(GTK_TREE_MODEL_SORT(obj1->pointer),
		(GtkTreeIter*)obj2->pointer, (GtkTreeIter*)obj3->pointer);
	
	lua_pushboolean(L, res);
	
	return 1;
#else
	gtk_tree_model_sort_convert_child_iter_to_iter(GTK_TREE_MODEL_SORT(obj1->pointer),
		(GtkTreeIter*)obj2->pointer, (GtkTreeIter*)obj3->pointer);
	
	return 0;
#endif
}

int lgui_tree_model_sort_convert_iter_to_child_iter(lua_State* L)
{
	luaL_checktype(L, 1, LUA_TUSERDATA);
	luaL_checktype(L, 2, LUA_TUSERDATA);
	luaL_checktype(L, 3, LUA_TUSERDATA);
	
	Object* obj1 = lua_touserdata(L, 1);
	Object* obj2 = lua_touserdata(L, 2);
	Object* obj3 = lua_touserdata(L, 3);
	
	gtk_tree_model_sort_convert_iter_to_child_iter(GTK_TREE_MODEL_SORT(obj1->pointer),
		(GtkTreeIter*)obj2->pointer, (GtkTreeIter*)obj3->pointer);
	
	return 0;
}
